/*  ScanDes.cmd

   Dieses Programm sucht zu den Dateinamen in dem aktuellen
   Verzeichnis die entsprechnden Dateibeschreibungen aus
   einer AllfilesListe (bergabeparameter).
   Dies ist sinnvoll, wenn Downloads archiviert werden
   sollen und man spter vielleicht einmal wissen mchte,
   was in einem Archiv eigentlich enthalten ist ;-)
   Die gefundenen Dateien werden im XCat-Format "beschrieben"
   (ggf. auch im 4OS2-Format).

   Der Ablauf sieht bei mir folgendermaen aus :
   Ich requeste z.B. eine Woche lang irgendwelche Files,
   verschiebe diese (nach einem Test auf Brauchbarkeit) ggf.
   in das Verzeichnis \MO-Cache (auf Platte) und wenn ich 
   dann mal wieder Lust habe, lasse ich ScanDes laufen und
   archiviere die Archive danach auf MO.


   Das Tool mGREP.EXE entspricht in etwa einem 
      GREP -E -b -i -n <such> <allfiles>
   Es ist blo ungleich schneller und baut sich den Suchausdruck
   selbst aus den Dateinamen im aktuellen Verzeichnis zusammen.


   Es knnen alle Allfileslisten durchsucht werden, die folgendes
   Format haben :
      Dateiname Junk Junk Beschreibung
   oder
      Dateiname Junk Junk [Junk] Beschreibung
   Leerzeichen sind jeweils Trennmarken. Eine Zeile, bei der
   die ersten beiden Zeichen NICHT zwei Leerzeichen sind, wird
   als Fortsetzung der Beschreibung gewertet.

   Legal wre z.B. :
      GFID11.ZIP      27,923 25-04-95  [033] GFID.EXE v1.1 sucht zu Dateinamen die
                                             entsprechenden Dateibeschreibungen aus
                                             AllfilesListen.
   als auch :
      GFID11.ZIP      27,923 25-04-95  GFID.EXE v1.1 sucht zu Dateinamen die
                                       entsprechenden Dateibeschreibungen aus
                                       AllfilesListen.


   "fn" ist anzupassen (default-Liste) !
   mGREP.EXE mu sich im PATH befinden


Detlev Ahlgrimm    20.06.1995
*/
PARSE ARG fn

IF fn="" THEN
   fn="E:\Modem\XP\FIDO\2405200A.FL"   /* default-Liste definieren - ANPASSEN ! */

IF RxFuncQuery('SysLoadFuncs')=1 THEN DO
   CALL RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
   CALL SysLoadFuncs
END

SIGNAL ON FAILURE NAME CLEANUP
SIGNAL ON HALT    NAME CLEANUP
SIGNAL ON SYNTAX  NAME CLEANUP

/* dies sind die Dateinamen, die gesucht werden sollen */
IF RIGHT(Directory(), 1)="\" THEN dir=Directory()"*"
ELSE                              dir=Directory()"\*"

/* eigene Queue anlegen */
MyQueue =RXQueue("Create")
OldQueue=RXQueue("Set", MyQueue)

SAY
SAY "Durchsuche        : "fn
SAY "nach den Files in : "dir
SAY

env=TRANSLATE(VALUE("COMSPEC",, "OS2ENVIRONMENT"))
IF POS("4OS2", env)>0 THEN des4os=1
ELSE                       des4os=0

/* Files einlesen (eigentlich berflssig) */
rc=SysFileTree(dir, "files.", "FO", "*--*-")
IF files.0=0 THEN DO
   SAY "Keine Dateien : "dir
   EXIT 1
END
files=""
DO i=1 TO files.0
   files=files TRANSLATE(FILESPEC("name", files.i))
END

/* Filenamen in der Allfiles suchen und in ln. ablegen */
'@mGREP 'fn' * | RxQueue' MyQueue
i=0
DO WHILE Queued()>0
   i=i+1
   PARSE PULL ln.i
END
ln.0=i

rc=STREAM(fn, "C", "OPEN READ")

DO i=1 TO ln.0
   PARSE VALUE ln.i WITH pos ":" junk

   /* direkt die Position anfahren, wo GREP den
      Such-Treffer gefunden hat  */
   rc=STREAM(fn, "C", "SEEK ="pos+1)

   /* erste Zeile einlesen */
   ln=LINEIN(fn)
   PARSE VALUE ln WITH name size date description

   /* ggf. Download-Counter entfernen */
   tst=POS("[", STRIP(description))
   IF tst>0 & tst<3 & POS("]", description)>0 THEN DO
      PARSE VALUE description WITH junk "[" cnt "]" description
   END

   /* Treffer war nicht der Name */
   IF WORDPOS(TRANSLATE(name), files)=0 THEN ITERATE

   /* solange weiterlesen, bis vorne ein neuer
      Dateiname gefunden wird */
   DO WHILE LINES(fn)
      ln=LINEIN(fn)
      IF LEFT(ln, 2)<>"  " THEN LEAVE
      description=description STRIP(ln)
   END

   /* und ab in die EAs damit */
   SAY LEFT(name, 12) "  " LEFT(STRIP(description), 50) "...usw..."
   rc=SysPutEA(name, "PROG_DESCRIPTION", STRIP(description))

   /* und noch eine Beschreibung fr 4OS2 absetzen, falls
      ScanDes.CMD unter 4OS2 luft */
   IF des4os=1 THEN
      "@DESCRIBE "name '"'TRANSLATE(STRIP(description), " ", '"')'"'
END


CLEANUP:
   rc=STREAM(fn, "C", "CLOSE")
   rc=RXQueue("Delete", MyQueue)
   rc=RXQueue("Set", OldQueue)
EXIT 0
